"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useScrollSections = exports.useScrollSection = void 0;
var react_1 = require("react");
var context_1 = require("./context");
var useScrollSection = function (id) {
    var _a = react_1.useContext(context_1.ScrollContext), scrollTo = _a.scrollTo, selectedSection = _a.selected;
    var onClick = function () { return scrollTo(id); };
    var selected = selectedSection === id;
    return { onClick: onClick, selected: selected };
};
exports.useScrollSection = useScrollSection;
var useScrollSections = function () {
    var _a = react_1.useContext(context_1.ScrollContext), scrollTo = _a.scrollTo, selectedSection = _a.selected, refs = _a.refs, meta = _a.meta;
    var sections = Object.keys(refs).map(function (id) { return ({
        id: id,
        meta: meta[id],
        onClick: function () { return scrollTo(id); },
        selected: selectedSection === id,
    }); });
    return sections;
};
exports.useScrollSections = useScrollSections;
//# sourceMappingURL=useScrollSection.js.map